{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Prog2x2;
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses TPInline,Def2x2,x1,Diffy,Objects,MatrDef,Hash2x2,ExprComp,Calcer;

Type

 PCompilator=^TCompilator;
 TCompilator=object(TExprCompilator) {  }
  DataBlocks:PBlockList;             {                    }
  LastFormula:PHashCell;             { ᫥ - ᢠ  }
  LastFunc:PHashCell;                { ᫥ -               }
  ProgrammCalcer:PBlockCalcer;
  constructor Init;
  procedure Translate;virtual;
  procedure Evaluate;virtual;
  function Calculate:PFloat;virtual;
  procedure NewLine; virtual;
  procedure Compile; virtual;
  function GetOutDesc(Num:integer; Var IdDef:TIdDef):boolean;
  function TranslateBlock(WhatBlock:byte):PBlockList;
  function CheckExtern(T:PToken; WhatBlock:byte):boolean; virtual;
  procedure TranslateList(LMode:ListModeType; UT:OpsType; Coll:PCollection);
  {procedure OutData;}
  function GetOutNums:word;
  destructor Done; virtual;
 private
  { 㦥 ६ }
  OutList:PListColl;
  InCycle:word;
  { True, ᫨  ࠭ While. -  ஫ Continue,Break.
     ६    - ᢠ  While ⠭- opUknown  }
  CurFuncName:TermString;
  DefsColl:PCollection;
  function TranslateWhile(WhatBlock:byte):PWhileCycle;
  function TranslateIf(WhatBlock:byte):PIfCycle;
  function TranslateCell(What:OpsType):PArrayCell;
  function TranslateDef(WhatBlock:byte; IsGlobal:boolean):PStructDef;
  procedure TranslateFuncDef(P:PBlockList; IsFunc:boolean);
  function TranslateFuncName(LocalHash:PTermHash; IsFunc:boolean):PFunction;
  function TranslatePrint:PBlockList;
  procedure TranslateExtern;
 end;

Implementation

Constructor TCompilator.Init;
Begin
{ ConstList:=nil; EndCList:=nil;}
 Inherited Init;
 CurFuncName:='';
 InCycle:=0;
 ProgrammCalcer:=nil;
 New(DefsColl, Init(10,5));
 DefColl:=DefsColl;
 OutList:=New(PListColl, Init(10,10));
End;

Procedure TCompilator.NewLine;
Begin End;

Function TCompilator.TranslateCell(What:OpsType):PArrayCell;
{ ࠭  ᢠ - ᨢ }
Var P:PArrayCell;
Begin
 GetTerm; { 室  [ }
 If TopTerm^.TermType<>opLBrack then
  With ATerms[not CurTerm] do ErrorJump(1,X+TermLen,Y,teLBrackExpected);
 GetTerm;
 P:=NewMemTmp(SizeOf(TArrayCell));

 With P^ do begin
  TranslateMath(Index,True); { ࠭᫨㥬 1-  }
  Case TopTerm^.TermType of
   opRBrack: Index2.FTree:=nil;
   opComma:
    If What=opArrayVar then begin
     GetTerm;
     TranslateMath(Index2,True) { ࠭᫨㥬 2-  }
    end
  end;

  With TopTerm^ do
   If TermType<>opRBrack then ErrorJump(1,X,Y,teRBrackExpected);
  GetTerm; { ய᪠ [ }
  With TopTerm^ do
   If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);
  GetTerm; { ய᪠ = }
  If What=opStrArrVar then begin
   FutureStrError:=teEndExpected;
   TranslateString(FTree)
  end
  else TranslateMath(FTree,True)
 end;
 TranslateCell:=P
End;

Function TCompilator.TranslateBlock(WhatBlock:byte):PBlockList;
Var BlockNull,P,OldP:PBlockList; OldT:PHashCell; Old:PToken;
    TF:PFormula; CheckTerminator,Return:boolean;
    N,NStruct,NDef,B:word; Op:OpsType; F:PFunction;
{ ࠭  ஢ }
{ CheckTerminator - ஢  ନ- : }
{ /: ;  endXXX,  teEndExpected             }
Begin
 N:=0; NDef:=0; NStruct:=0;
 Return:=False;
 BlockNull:=NewMemTmp(SizeOf(TBlockList));
 {    ᯨ᪥ - 㦥; ᮤন ࠧ. -  ᫥ -஢   }
 With BlockNull^ do begin
  What:=etNull; Next:=nil
 end;
 OldP:=BlockNull;
 GetTerm;

 Repeat
  CheckTerminator:=True;

  With TopTerm^ do begin
   Op:=TermType;

   Case Op of
    opPar..opNewVar:begin { - ᢠ ᫮ ६ }
     OldT:=TopTerm^.Ref; { Hash - }
     Inc(N); { N=᫮ 塞 - }
     P:=NewMemTmp(SizeOf(TBlockList));
     TF:=NewMem(SizeOf(TFormula));
     P^.Expr:=TF;
     P^.What:=etFormula;
     TF^.Loc:=OldT;

     GetTerm; { 室  = }
     With TopTerm^ do
      If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);

     GetTerm; { ய᪠ = }
     TranslateMath(TF^.E,True); { ࠭ ࠢ  }

     If ParInExpr then OldT^.TermType:=opPar {  ࠦ  ⨯ Par }
     else
      If ExNeed or (InCycle<>0) then OldT^.TermType:=opUknown { -  ᮪ }
      else
       Case Op of
        opNewVar: OldT^.TermType:=opVar; { - - ⠭ }
        opVar: OldT^.TermType:=opDoubleVar; { - - ८।塞 ⠭ }
       end;

     If WhatBlock=wbGlobal then begin
      If not IsDiff then LastFunc:=OldT;
      LastFormula:=OldT { ᫥ - ᢠ }
     end
    end;

    opArrayVar..opStrArrVar:begin { - ᢠ - ᨢ }
     OldT:=TopTerm^.Ref;
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      If Op=opStrArrVar then What:=etStrArrayCell else What:=etArrayCell;
      Expr:=TranslateCell(Op);
      PArrayCell(Expr)^.Loc:=OldT
     end
    end;

    opStringVar..opStringPar:begin
     OldT:=TopTerm^.Ref; { Hash - }
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     TF:=NewMem(SizeOf(TFormula));
     P^.Expr:=TF;
     TF^.Loc:=OldT;
     GetTerm; { 砥 = }
     With TopTerm^ do
      If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);
     GetTerm; { ய᪠ = }
     FutureStrError:=teEndExpected;
     TranslateString(TF^.E);
     If Op<>opStringPar then
      If ExNeed or (InCycle<>0) then OldT^.TermType:=opStringPar
      else
       case Op of
        opStringVar: OldT^.TermType:=opStringDouble;
        opNewStringVar: OldT^.TermType:=opStringVar;
       end;
     P^.What:=etStrFormula
    end;

    opIf..opRepeat:begin
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=Op-opIf+2;
      GetTerm; { ய᪠ If/While }
      If Op=opWhile then begin
       Inc(InCycle);
       Expr:=TranslateWhile(WhatBlock);
       Dec(InCycle)
      end
      else begin
       Inc(InCycle,$100);
       Expr:=TranslateIf(WhatBlock);
       Dec(InCycle,$100)
      end
     end
    end;

    opEndWhile..opEnd:
     If WhatBlock=wbGlobal then ErrorJump(0,X,Y,teEIS) { end   祬  ⭮ }
     else begin
      CheckTerminator:=False;
      Return:=True
     end;

    opPrint:begin
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=etPrint;
      Expr:=TranslatePrint
     end;
    end;

    opSemiColon,opBegin:begin { ⮩ - }
     GetTerm;
     CheckTerminator:=False
    end;

    opArrayDef..opPolinomDef:begin
     { ᠭ / ⮫쪮    ᠭ -,    If  While }
     Case WhatBlock of
      wbGlobal,wbFuncDef: ;
      else ErrorJump(0,X,Y,teLocArrDef+Op-opArrayDef)
     end;
     Inc(NDef); { NDef=᫮ ᠭ }
     If Op=opArrayDef then Inc(NStruct);
     { NStruct=᫮ ᠭ ᨢ }

     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=Op-AropetDel;
      Expr:=TranslateDef(What,WhatBlock=wbGlobal)
     end;
    end;

    opFuncDef,opProcDef:begin
     Case WhatBlock of
      wbGlobal,wbFuncDef: ;
      else ErrorJump(0,X,Y,teLocFuncDef)
     end;
     Inc(NDef);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      If Op=opFuncDef then What:=etFuncDef else What:=etProcDef;
      TranslateFuncDef(P,Op=opFuncDef)
     end;
    end;

    opUserFunc,opStringFunc:begin
     Old:=TopTerm;
     Inc(N);
     P:=NewMemTmp(SizeOf(TBlockList));
     F:=PFunction(PHashCell(Old^.Ref)^.WhatD);
     B:=F^.EnableAssign;
     If (PHashCell(Old^.Ref)^.Name=CurFuncName) or ((B<>0) and (F^.NPars=0)) then begin
      { ᢮ - १- -  --property  - }
      GetTerm; { 砥 = }
      With TopTerm^ do
       If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);
      TF:=NewMem(SizeOf(TFormula));
      P^.Expr:=TF;
      TF^.Loc:=Old^.Ref;
      GetTerm; { ய᪠ = }
      If Op=opUserFunc then begin
       P^.What:=etFormula;
       TranslateMath(TF^.E,True)
      end
      else begin
       FutureStrError:=teEndExpected;
       TranslateString(TF^.E);
       P^.What:=etStrFormula
      end
     end
     else begin
      If B=0 then
       With Old^ do begin
        GetTerm; { 砥 = }
        If TopTerm^.TermType=opAssign then ErrorJump(0,X,Y,teDoubleName)
        else ErrorJump(1,X,Y,teEIS);
       end;
      { --property  - }
      TF:=NewMem(SizeOf(TPropFormula));
      P^.Expr:=TF;
      PPropFormula(TF)^.Loc:=Old^.Ref;
      PPropFormula(TF)^.Func:=F;
      If Op=opUserFunc then begin
       P^.What:=etFuncProp;
       TranslateMath(PPropFormula(TF)^.LValue,True);
       With TopTerm^ do
        If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);
       GetTerm; { ய᪠ = }
       TranslateMath(PPropFormula(TF)^.RValue,True)
      end
      else begin
       FutureStrError:=teEndExpected;
       TranslateString(PPropFormula(TF)^.LValue);
       With TopTerm^ do
        If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);
       GetTerm; { ய᪠ = }
       TranslateString(PPropFormula(TF)^.RValue);
       P^.What:=etStrFuncProp;
      end
     end;
    end;

    opUserProc,opParProc,opDirectProc:begin
     OldT:=TopTerm^.Ref; { Hash - }
     Inc(N); { N=᫮ 塞 - }
     P:=NewMemTmp(SizeOf(TBlockList));
     TF:=NewMem(SizeOf(TExpression));
     P^.Expr:=TF;
     P^.What:=etProc;
     TranslateMath(PExpression(TF)^,False);
    end;

    opBreak..opExit:begin
     If Op<>opExit then
      { 室  While? }
      If InCycle and $FF=0 then ErrorJump(0,X,Y,teEIS);
     P:=NewMemTmp(SizeOf(TBlockList));
     With P^ do begin
      What:=Op;
      GetTerm { ய᪠ Break }
     end;
     Inc(N)
    end;

    opParDef:begin
     If WhatBlock<>wbGlobal then ErrorJump(0,X,Y,teInvParDefLoc);
     TranslateList(lmParList,0,PCollection(ParList));
     CheckTerminator:=False
    end;

    opStringDef:begin
     Case WhatBlock of
      wbGlobal,wbFuncDef,wbProcDef: ;
      else ErrorJump(0,X,Y,teInvStringDefLoc);
     end;
     TranslateList(lmStringList,0,nil);
     CheckTerminator:=False
    end;

    opUserType1..opUserType2:begin
     Case WhatBlock of
      wbGlobal,wbFuncDef,wbProcDef: ;
      else ErrorJump(0,X,Y,teInvUserTypeDefLoc);
     end;
     TranslateList(lmUserVarList,Op+UserTypeVarDelta,nil);
     CheckTerminator:=False
    end;

    opExtern:begin
     If WhatBlock=wbGlobal then ErrorJump(0,X,Y,teExternInGlobal);
     TranslateExtern;
     CheckTerminator:=False
    end;

    opOut:begin
     If WhatBlock<>wbGlobal then ErrorJump(0,X,Y,teInvOutLoc);
     TranslateList(lmOutList,0,PCollection(OutList));
     CheckTerminator:=False
    end;

    opUserVar1..opUserVar2:begin
     P:=NewMemTmp(SizeOf(TBlockList));
     Inc(N);
     With P^ do begin
      What:=etUserTypeFormula;
      TF:=NewMemTmp(SizeOf(TUserTypeFormula));
      P^.Expr:=TF;
      PUserTypeFormula(TF)^.LocL:=TopTerm^.Ref;
      GetTerm; { 砥 = }
      With TopTerm^ do
       If TermType<>opAssign then ErrorJump(1,X,Y,teAssignExpected);
      GetTerm; { ய᪠ = }
      with PUserTypeFormula(TF)^ do
       If TopTerm^.TermType=Op then
        LocR:=TopTerm^.Ref
       else
        If TopTerm^.TermType=Op-UserTypeVarDelta then begin
         GetTerm; { ய᪠ opUserType, 砥 ( }
         With TopTerm^ do
          If TermType<>opLBra then ErrorJump(1,X,Y,teLBraExpected);
         GetTerm; { ய᪠ ( }
         case TopTerm^.TermType of
          opConst..opVar,opUserVar1..opUserVar2:
           PUserTypeFormula(TF)^.LocR:=TopTerm^.Ref;
          else With TopTerm^ do ErrorJump(1,X,Y,teBadPrivOp);
         end;
         GetTerm; { 砥 ) }
         With TopTerm^ do
          If TermType<>opRBra then ErrorJump(1,X,Y,teRBraExpected);
         GetTerm; { ய᪠ ) }
        end
        else begin
         {ErrorTxt:=PUserTypeFormula(TF)^.LocL^.Name;}
         ErrorData:=Op-UserTypeVarDelta;
         With TopTerm^ do ErrorJump(1,X,Y,teUserVarExpected);
        end
     end;
    end;

    opEndData:
     If WhatBlock=wbGlobal then begin
      CheckTerminator:=False;
      Return:=True
     end
     else ErrorJump(0,X,Y,teUnexpectedEnd);

    else ErrorJump(0,X,Y,teEIS);
   end { case }
  end; {with }

  If CheckTerminator then With TopTerm^ do begin
   Case TermType of
    opSemiColon: GetTerm;
    opEndData..opEnd: ;
    else ErrorJump(0,X,Y,teEndExpected)
   end;
   P^.Next:=nil;
   OldP^.Next:=P; OldP:=P
  end;
 until Return;

 If N=0 then With TopTerm^ do
  If WhatBlock=wbGlobal then ErrorJump(0,X,Y,teNoData)
  {else ErrorJump(0,X,Y,teNoDataInCycle)};

 BlockNull^.NDefBlocks:=NDef;
 BlockNull^.NBlocks:=N;
 BlockNull^.NStructDefs:=NStruct;
 TranslateBlock:=BlockNull
End;

Function TCompilator.TranslateWhile(WhatBlock:byte):PWhileCycle;
Var P:PWhileCycle;
Begin
 P:=NewMem(SizeOf(TWhileCycle));
 With P^ do begin
  NLogCalcs:=0;
  NBraL:=0;
  Logic:=TranslateLogic(False,False);
  NBraL:=0;
  With TopTerm^ do begin
   Case TermType of
    opDo: ;
    else ErrorJump(0,X,Y,teDoExpected); { opThen,opBadLog }
   end;
   LogCalcs:=NLogCalcs;
   BList:=TranslateBlock((WhatBlock and wbFuncDef)+wbWhile)
  end;
  With TopTerm^ do
   Case TermType of
    opEndWhile,opEnd: ;
    else ErrorJump(0,X,Y,teEndWhileExpected);
   end;
  GetTerm
 end;
 TranslateWhile:=P
End;

Function TCompilator.TranslateDef(WhatBlock:byte; IsGlobal:boolean):PStructDef;
Var A:PStructDef; CL,OldCL:PCellList; NameTerm:TToken; B:boolean; t,I:byte;
Begin
 If (WhatBlock=wbPolinomDef) and not IsGlobal then
  With TopTerm^ do ErrorJump(0,X,Y,tePolDefLoc);
 {   뢠  -, ..  /
   ந樠஢,   饭  -     }
 GetTerm; { ய᪠ Array/Polinom }
 Dec(WhatBlock,wbArrayDef);
 A:=NewMem(SizeOf(TStructDef));

 With TopTerm^ do
  If TermType<>opLBrack then ErrorJump(0,X,Y,teLBrackExpected);
 GetTerm; { ய᪠ [ }

 { ࠭᫨㥬 ࠧ୮ }
 With A^ do begin
  TranslateMath(SizeVal,True); { - ࠧ }
  B:=ParInExpr or ExNeed;

  { ࠧ     Par }
  If B then With SizeVal do ErrorJump(0,LocX,LocY,teParInSizeVal);

  Case TopTerm^.TermType of
   opRBrack: Size2Val.FTree:=nil;
   opComma:
    If (WhatBlock=0) then begin
     GetTerm;
     TranslateMath(Size2Val,True);
     B:=(ParInExpr or ExNeed);
     If B then With Size2Val do ErrorJump(0,LocX,LocY,teParInSizeVal);
    end
  end;
 end;

 With TopTerm^ do
  If TermType<>opRBrack then ErrorJump(0,X,Y,teRBrackExpected);
 GetTerm; { ய᪠ ] }

 If WhatBlock=0 then begin { ᨢ,  Polinom }
  { - ⨯ - }
  Case TopTerm^.TermType of
   opSimm: begin t:=SimmM; GetTerm end;
   opDiag: begin t:=DiagM; GetTerm end;
   else t:=GeneralM
  end;

  If TopTerm^.TermType=opOf then begin
   GetTerm; { ய᪠ of }
   If TopTerm^.TermType=opStringDef then begin
    If t<>GeneralM then With TopTerm^ do ErrorJump(0,X,Y,teStrArNoGeneral);
    GetTerm; { ய᪠ string }
    If TopTerm^.TermType<>opLBrack then I:=TextTermSize-1
    else begin
     GetTerm; { ய᪠ [ }
     With TopTerm^ do begin
      If (TermType<>opConst) or (Frac(PFloat(Ref)^)<>0) then
       ErrorJump(1,X,Y,teConstExpected);
      If (PFloat(Ref)^<1) or (PFloat(Ref)^>TextTermSize-1) then
       ErrorJump(0,X,Y,teInvStrLenDef);
      I:=Round(PFloat(Ref)^);
      GetTerm; { 室  ] }
      With TopTerm^ do
       If TermType<>opRBrack then ErrorJump(0,X,Y,teRBrackExpected);
      GetTerm; { ய᪠ ] }
     end
    end;
    t:=StringM;
    longint(A^.Data):=longint(I);
   end
   else With TopTerm^ do ErrorJump(1,X,Y,teStringDefExpected)
  end;
 end;

 NameTerm:=TopTerm^;

 With TopTerm^ do
  Case TermType of
   opNewVar: ;
   opPar..opMatrixVar,opUserVar1..opUserVar2: ErrorJump(0,X,Y,teOriginNameExpected);
   else ErrorJump(1,X,Y,teArrayNameExpected+WhatBlock);
  end;

 With NameTerm do begin
  { 塞  opNewVar  opArrayVar,opPolinom ⮫쪮 ᫥  }
  { TransFormula: ࠭  訡 ⨯ "Array A[ 2*A[1] ]" }
  If t=StringM then PHashCell(Ref)^.TermType:=opStrArrVar
  else PHashCell(Ref)^.TermType:=opArrayVar+WhatBlock;
  PHashCell(Ref)^.WhatD:=A
 end;

 With A^ do begin
  NameHash:=PHashCell(NameTerm.Ref);
  CellList:=nil;
  Cells:=0;
  Extern:=False;
  MType:=t;
  GetTerm; { ய᪠  }
 end;

 With TopTerm^ do
  If TermType<>opAssign then begin {  -樨 }
   If (WhatBlock=1) and IsGlobal then { Polinom / ந- }
    ErrorJump(0,X,Y,teAssignExpected);
   TranslateDef:=A;
   exit
  end
  else
   If not IsGlobal and (WhatBlock=1) then ErrorJump(0,X,Y,teEndExpected);
 GetTerm; { ய᪠ = }

 With A^ do begin
  B:=False;
  CL:=NewMemTmp(SizeOf(TCellList));
  CellList:=CL; OldCL:=CL;

  If TopTerm^.TermType=opExtern then begin
   { ஢塞,    ⠪ ᨢ/ }
   If not CheckExtern(@NameTerm,WhatBlock+wbArrayDef) then
    With NameTerm do ErrorJump(0,X,Y,teNotExternAr+WhatBlock);
   Extern:=True;
   TranslateDef:=A;
   GetTerm  { ய᪠ Extern }
  end
  else begin
   If IsGlobal=False then
    With ATerms[not CurTerm] do ErrorJump(0,X,Y,teEndArrDefExpected);
   Repeat
    CL:=NewMemTmp(SizeOf(TCellList));
    Inc(Cells);

    With CL^ do begin
     Next:=nil;
     If t=StringM then begin { - of string }
      TranslateString(F);
      If ParInExpr or ExNeed then { 祭 -  ᫨ }
       With F do ErrorJump(0,LocX,LocY,teParInCellVal);
     end

     else begin { - of float }
      TranslateMath(F,True);
      If ParInExpr or ExNeed then { 祭 -  ᫨ }
       With NameTerm do ErrorJump(0,X,Y,teParInCellVal);
     end;
    end;

    OldCL^.Next:=CL; OldCL:=CL;
    With TopTerm^ do
     Case TermType of
      opSemiColon: B:=True;
      opComma: GetTerm;
      else ErrorJump(1,X,Y,teEndExpected)
     end;
   until B
  end
 end;
 TranslateDef:=A
End;

Function TCompilator.TranslateIf(WhatBlock:byte):PIfCycle;
Var P:PIfCycle;
Begin
 P:=NewMem(SizeOf(TIfCycle));
 With P^ do begin
  NLogCalcs:=0;
  NBraL:=0;
  { ࠭᫨㥬 ᫮ }
  Logic:=TranslateLogic(False,False);
  NBraL:=0;
  With TopTerm^ do begin
   Case TermType of
    opThen: ;
    else ErrorJump(0,X,Y,teThenExpected); { opDo,opBadLog }
   end;
   LogCalcs:=NLogCalcs;
   { ࠭᫨㥬 ⥫ If }
   BListIf:=TranslateBlock((WhatBlock and wbFuncDef)+wbIf)
  end;
  With TopTerm^ do
   Case TermType of
    opEndIf,opEnd: ;
    else ErrorJump(0,X,Y,teEndIfExpected);
   end;

  GetTerm; { ய᪠ opEndIf }
  If TopTerm^.TermType=opElse then begin
   { ࠭᫨㥬 ⥫ Else }
   BListElse:=TranslateBlock(wbElse);
   With TopTerm^ do
    Case TermType of
     opEndElse,opEnd: ;
     else ErrorJump(0,X,Y,teEndElseExpected);
    end;
   GetTerm; { ய᪠ opEndElse }
  end
  else BListElse:=nil
 end;
 TranslateIf:=P
End;

Procedure TCompilator.TranslateExtern;
Var O,H:PHashCell;
Begin
 Repeat
  GetTerm; { 砥  }
  If TopTerm^.TermType<>opNewVar then
   With TopTerm^ do ErrorJump(1,X,Y,teLocAsGlobal);
  O:=TopTerm^.Ref; { Hash  . Hash-⠡ }
  If CHash^.Prev^.Search(O^.Name,False,AllMask and not FuncMask,H)
  then begin
   Case H^.TermType of
    opVar,opDoubleVar: H^.TermType:=opUknown;
    opStringVar..opStringDouble: H^.TermType:=opStringPar;
   end;
   O^.HVal:=H
  end
  else With TopTerm^ do ErrorJump(0,X,Y,teNotExistInGlobal);

  GetTerm; { ய᪠  }
  Case TopTerm^.TermType of
   opComma:;
   opSemiColon: break;
   else With TopTerm^ do ErrorJump(1,X,Y,teEndExpected);
  end
 until False
End;

Procedure TCompilator.TranslateFuncDef(P:PBlockList; IsFunc:boolean);
Var Old,LocalHash:PTermHash; OldFuncName:TermString;
Begin
 { ᮧ .   ⠢塞   DefColl }
 LocalHash:=New(PTermHash, Init(@Self,nil));
 DefColl^.Insert(LocalHash);
 Old:=CHash; { - ⥪.  }

 { ࠡ- ᠭ - }
 P^.Expr:=TranslateFuncName(LocalHash,IsFunc);
 LocalHash^.Prev:=Old; {  㯠   - ।. ஢ }

 OldFuncName:=CurFuncName; { -  砩  - }

 {  ⥪. -: -  ஫ ᢠ - - }
 { e.g. 'Func A(...); A=5... end;' ,  B=5,  B-⮦ - - }
 CurFuncName:=PFunction(P^.Expr)^.FuncName^.Name;
 { ࠡ- ⥫ - }
 PFunction(P^.Expr)^.FuncCalc:=TranslateBlock(wbFuncDef);
 CurFuncName:=OldFuncName;

 CHash:=Old; { - ⥪.  }

 { 㤠塞 . . ᫨  - -  ErrorJump, 
    㤥 㤠 ⥬ Dispose(DefColl, Done) }
 DefColl^.Free(LocalHash); { 㤠塞 . }

 With TopTerm^ do
  Case TermType of
   opEndFunc,opEnd: ;
   else ErrorJump(0,X,Y,teEndFuncExpected)
  end;
 GetTerm { ய᪠ opEndFunc }
End;

Function TCompilator.TranslateFuncName(LocalHash:PTermHash; IsFunc:boolean):PFunction;
Var Main,P,H:PHashCell; F,Fp:PFunction; VarPar,B1,B2:boolean; Op,I:OpsType; S:string[1];

 Procedure AAA(Var Fn:PFunction; AIsFunc:boolean); { ࠡ⪠  - }
 Var Old:PTermHash;
 Begin
  Old:=CHash^.Prev;
  CHash^.Prev:=nil;
  GetTerm; { 砥  -; 㤥 ᥭ  GlobalHash  }
           {  -   LocalHash   -      }
  CHash^.Prev:=Old;
  With TopTerm^ do begin
   Case TermType of {  - 㭨쭮? }
    opNewVar: ; {  }
    opPar..opMatrixVar,opParFunc..opDirectStrFunc,
    opStringVar..opStringPar,opUserVar1..opUserVar2:
     ErrorJump(0,X,Y,teDoubleName);
    else ErrorJump(1,X,Y,teFuncNameExpected);
   end;
   P:=Ref; { Hash  }
   { ॣ㥬  -  ⥪.  }
   If AIsFunc then P^.TermType:=opUserFunc else P^.TermType:=opUserProc;
  end;

  GetTerm; { 砥 ( }
  With TopTerm^ do
   If TermType<>opLBra then ErrorJump(0,X,Y,teLBraExpected);

  Fn:=NewMem(SizeOf(TFunction));
  P^.WhatD:=Fn; {  Hash  - 㪠-  ᠭ - }
  With Fn^ do begin
   NPars:=0; NParVars:=0; SimpleIfAllConst:=False;
   FuncName:=P; { Hash  - }
  end
 end;

 Procedure ValidNPars(Fn:PFunction);
 Begin
  Inc(Fn^.NPars);
  If Fn^.NPars>MaxFuncPars then
   With TopTerm^ do ErrorJump(0,X,Y,teTooManyPars);
  If VarPar then Inc(Fn^.NParVars);
 End;

Begin
 AAA(F,IsFunc); { ࠡ-  ॣ-  - }
 If IsFunc then begin
  { 㡫㥬  -  LocalHash   祭 -) }
  LocalHash^.Search(P^.Name,True,AllMask,H);
  H^.TermType:=opUserFunc;
  H^.WhatD:=F;
  F^.FuncName:=H;
 end;
 F^.EnableAssign:=0;

 Main:=P;
 CHash:=LocalHash;

 GetTerm; { ய᪠ ( }
 B1:=False;

 Repeat { 横  ࠬࠬ }
  VarPar:=TopTerm^.TermType=opOutSign;
  {  @ ।  - ᫥ ।-  뫪 }
  If VarPar then GetTerm; { ய᪠ @ }

  With TopTerm^ do begin
   Op:=TermType;
   Case Op of
    opNewVar:begin { --६ }
     PHashCell(Ref)^.TermType:=opUknown;
     { ⮡ ६  뫮 ᮪ }
     With F^ do begin
      ValidNPars(F);
      With Pars[NPars] do begin
       Hash:=Ref;
       If VarPar then TermType:=opPar else TermType:=opVar
      end
     end
    end;

    opArrayDef..opMatrixDef:begin
     VarPar:=False;
     GetTerm; { ய᪠ Array/Polinom/Matrix }
     If TopTerm^.TermType=opOf then begin
      GetTerm; { ய᪠ Of }
      With TopTerm^ do
       If TermType<>opStringDef then ErrorJump(0,X,Y,teStringDefExpected);
      GetTerm; { ய᪠ string }
      I:=opStrArrVar
     end
     else I:=Op-OpArDel;
     With TopTerm^ do
      Case TermType of {  - 㭨쭮? }
       opNewVar:begin
        PHashCell(Ref)^.TermType:=I;
        { ᮧ PStructDef,  Data ன 㤥 । 䠪. - Data }
        PHashCell(Ref)^.WhatD:=NewMem(SizeOf(TStructDef));
        ValidNPars(F);
        With F^ do begin
         Pars[NPars].Hash:=Ref; {   }
         Pars[NPars].TermType:=I
        end
       end;
       opPar..opMatrixVar: ErrorJump(0,X,Y,teDoubleName);
       else ErrorJump(1,X,Y,teVarNameExpected);
      end
    end;

    opFuncDef,opProcDef:begin { - - - }
     B2:=False;
     VarPar:=False;
     AAA(Fp,Op=opFuncDef);
     If Op=opFuncDef then P^.TermType:=opParFunc else P^.TermType:=opParProc;
     ValidNPars(F);
     With F^ do begin
      Pars[NPars].Hash:=Fp^.FuncName;
      If Op=opFuncDef then Pars[NPars].TermType:=opUserFunc
      else Pars[NPars].TermType:=opUserProc
     end;
     GetTerm; { ய᪠ Func }

     Repeat { 横  - }
      With TopTerm^ do
       Case TermType of
        opFunc2:
         If TermWhat=moMult then With Fp^ do begin { * - ᫮ ६ }
          ValidNPars(Fp);
          With Fp^ do Pars[NPars].TermType:=opVar
         end
         else ErrorJump(0,X,Y,teFuncSignsExpected);

        opOutSign:begin { @ - ᫮ ६-뫪 }
         ValidNPars(Fp);
         With Fp^ do Pars[NPars].TermType:=opPar
        end;

        opArrayDef..opPolinom:begin
         ValidNPars(Fp);
         With Fp^ do Pars[NPars].TermType:=TopTerm^.TermType-OpArDel
        end;

        opRBra:
         { ᫥ ⮩ / ᨬ - }
         If Fp^.NPars<>0 then ErrorJump(1,X,Y,teFuncSignsExpected)
         { -  - }
         else Break;

        else ErrorJump(1,X,Y,teFuncSignsExpected);
       end; { case }
      GetTerm;
      With TopTerm^ do
       Case TermType of
        opComma: GetTerm; { 室  ᫥. - }
        opRBra: B2:=True;
        else ErrorJump(0,X,Y,teCommaExpected);
       end;
     until B2;
    end;

    opStringDef,opUserType1..opUserType2:begin
     GetTerm; { ய᪠ string/opUserType }
     With TopTerm^ do
      Case TermType of
       opNewVar:begin
        With PHashCell(Ref)^ do begin
         If Op=opStringDef then begin
          TermType:=opStringPar;
          ValueP:=NewMem(TextTermSize)
         end
         else TermType:=Op+UserTypeVarDelta
        end;
        ValidNPars(F);
        With F^ do begin
         Pars[NPars].Hash:=Ref; {   }
         If Op=opStringDef then
          If VarPar then Pars[NPars].TermType:=opStringPar
          else Pars[NPars].TermType:=opStringVar
         else
          Pars[NPars].TermType:=PHashCell(Ref)^.TermType;
         Pars[NPars].UTFlag:=word(VarPar); { utfByPar  VarPar=True }
        end
       end;
       opPar..opMatrixVar,opParFunc..opDirectStrFunc,opStringVar..opStringPar,
       opUserVar1..opUserVar2: ErrorJump(0,X,Y,teDoubleName);
       else ErrorJump(1,X,Y,teVarNameExpected);
      end
    end;

    opPar..opMatrixVar,opUserVar1..opUserVar2: ErrorJump(0,X,Y,teDoubleName);

    opRBra:begin
     If VarPar then ErrorJump(0,X,Y,teVarNameExpected);
     break
    end;

    else ErrorJump(1,X,Y,teVarNameExpected)
   end; { case }

   GetTerm;
   With TopTerm^ do
    Case TermType of
     opComma: GetTerm; { 室  ᫥. - }
     opRBra: B1:=True;
     else ErrorJump(0,X,Y,teCommaExpected);
    end;
  end;
 until B1;

 GetTerm;
 If IsFunc and (TopTerm^.TermType=opColon) then begin { - ⨯ string }
  GetTerm; { ய᪠ : }
  If TopTerm^.TermType=opStringDef then begin
   H^.TermType:=opStringFunc;
   Main^.TermType:=opStringFunc;
   {    - ।-   ப }
   H^.ValueP:=NewString(S,False)
  end
  else With TopTerm^ do ErrorJump(1,X,Y,teStringDefExpected);
  GetTerm { ய᪠ string }
 end;

 With TopTerm^ do
  If TermType<>opSemiColon then ErrorJump(1,X,Y,teEndExpected);
 TranslateFuncName:=F
End;

Function TCompilator.TranslatePrint:PBlockList;
Var B,ExpFormat,Co:boolean; BlockNull,OldP,P:PBlockList; TP:PPrintRec; N:word; I1,I2:integer;

 Procedure GetFormat(Var I:integer);
 Var E:Float; cod:integer;
 Begin
  GetTerm;
  With TopTerm^ do begin
   If TermType<>opConst then ErrorJump(1,X,Y,teConstExpected);
   E:=PFloat(Ref)^;
   If Frac(E)<>0 then ErrorJump(0,X,Y,teConstExpected);
   If (E<0) or (E>30) then ErrorJump(0,X,Y,teInvFormat);
   I:=Round(E)
  end
 End;

Begin
 N:=0; B:=False;
 BlockNull:=NewMemTmp(SizeOf(TBlockList));
 OldP:=BlockNull;
 OldP^.Next:=nil;
 FutureStrError:=teRBraExpected;

 GetTerm; { 室  ( }
 With TopTerm^ do
  If TermType<>opLBra then ErrorJump(0,X,Y,teLBraExpected);

 NBraL:=1;
 Co:=False;

 Repeat
  GetTerm;
  With TopTerm^ do
   Case TermType of
    opRBra:
     If Co then
      With ATerms[not CurTerm] do ErrorJump(0,X,Y,teCommaUnnecessary)
     else break; { ᯨ᮪  }

    opStringConst..opStringPar,opStringFunc,opDirectStrFunc,opStrArrVar:begin
     TP:=NewMemTmp(SizeOf(TPrintRec));
     TranslateString(TP^.F);
     P:=NewMemTmp(SizeOf(TBlockList));
     Inc(N);
     P^.What:=etStrFormula;
     P^.Expr:=TP;
    end;

    else begin
     TP:=NewMemTmp(SizeOf(TPrintRec));
     TranslateMath(TP^.F,True);
     P:=NewMemTmp(SizeOf(TBlockList));
     Inc(N);
     P^.What:=etFormula;
     P^.Expr:=TP;

     I1:=$FF; I2:=$FF; ExpFormat:=False;
     If TopTerm^.TermType=opColon then begin
      GetFormat(I1);
      GetTerm;
      If TopTerm^.TermType=opColon then begin
       GetFormat(I2);
       GetTerm
      end
     end;

     If I1=$FF then begin
      I1:=stFormat1; I2:=stFormat2
     end
     else
      If I2=$FF then begin
       ExpFormat:=True;
       If I1>26 then I1:=26
       else
        If I1<10 then I1:=10
      end
      else begin
       If I1<2 then I1:=2;
       If I1-I2<2 then I2:=0
      end;

     With TP^ do begin
      Expo:=ExpFormat;
      F1:=I1; F2:=I2
     end
    end
   end; { case }

  Co:=False;
  With TopTerm^ do
   Case TermType of
    opComma: Co:=True;
    opRBra: B:=True;
    else ErrorJump(0,X,Y,teRBraExpected)
   end;

  OldP^.Next:=P;
  P^.Next:=nil; OldP:=P
 until B;

 NBraL:=0;
 TransError:=0;
 GetTerm; { ய᪠ ) }

 BlockNull^.NBlocks:=N;
 TranslatePrint:=BlockNull
End;

Procedure TCompilator.TranslateList(LMode:ListModeType; UT:OpsType; Coll:PCollection);
Var OK,ExpFormat:boolean; OV:POutVar; I1,I2:integer; J:word; S:string[1];

 Procedure GetFormat(Var I:integer);
 Var E:Float; cod:integer;
 Begin
  GetTerm;
  Case TopTerm^.TermType of
   opComma: ;
   opEndData,opSemiColon: OK:=True;
   opColon:begin
    If LMode in [lmStringList,lmUserVarList] then
     With TopTerm^ do ErrorJump(0,X,Y,teCommaExpected);
    GetTerm;
    With TopTerm^ do begin
     If TermType<>opConst then ErrorJump(1,X,Y,teConstExpected);
     E:=PFloat(Ref)^;
     If Frac(E)<>0 then ErrorJump(0,X,Y,teConstExpected);
     If (E<0) or (E>30) then ErrorJump(0,X,Y,teInvFormat);
     I:=Round(E)
    end
   end;
   else With TopTerm^ do ErrorJump(1,X,Y,teCommaExpected)
  end
 End;

Begin
 OK:=False;
 Repeat
  I1:=$FF;
  I2:=$FF;
  ExpFormat:=False;
  J:=0;

  GetTerm;
  With TopTerm^ do begin
   Case TermType of
    opPar..opVar:
     If LMode<>lmOutList then J:=teDoubleName;

    opNewVar:
     Case LMode of
      lmParList:
       If IsDiff then J:=teParDiff
       else PHashCell(Ref)^.TermType:=opPar;

      lmStringList:
       If IsDiff then J:=teStringDiff
       else begin
        PHashCell(Ref)^.TermType:=opNewStringVar;
        PHashCell(Ref)^.ValueP:=NewString(S,False)
       end;

      lmUserVarList:
       If IsDiff then begin
        J:=teUserTypeDiff;
        ErrorData:=UT-UserTypeVarDelta
       end
       else
        with PHashCell(Ref)^ do begin
         TermType:=UT;
         Value:=0 { ⨯ - - 㫥 - }
        end;

      else J:=teUknownVar
     end;

    opArrayVar..opMatrixVar:
     If LMode<>lmOutList then J:=teDoubleName else J:=teStructNotOut;

    opStringVar..opStringPar:
     If LMode<>lmOutList then J:=teDoubleName else J:=teStringNotOut;

    opUserVar1..opUserVar2:
     If LMode<>lmOutList then J:=teDoubleName
     else begin
      J:=teUserTypeNotOut;
      ErrorData:=UT-UserTypeVarDelta
     end;
    else ErrorJump(1,X,Y,teVarNameExpected)
   end;

   If J<>0 then ErrorJump(0,X,Y,J);
   If LMode in [lmStringList,lmUserVarList] then begin
    GetFormat(I1); { ஢塞  opComma }
    continue
   end;

   New(OV);
   Coll^.Insert(OV);
   With OV^ do begin
    HVar:=Ref;
    Diff:=IsDiff
   end
  end;

  GetFormat(I1);
  If TopTerm^.TermType=opConst then GetFormat(I2);

  If I1=$FF then begin
   I1:=stFormat1; I2:=stFormat2
  end
  else
   If I2=$FF then begin
    ExpFormat:=True;
    If I1>26 then I1:=26
    else
     If I1<10 then I1:=10
   end
   else begin
    If I1<2 then I1:=2;
    If I1-I2<2 then I2:=0
   end;

  With OV^ do begin
   Expo:=ExpFormat;
   F1:=I1; F2:=I2
  end
 until OK
End;

Function TCompilator.GetOutNums:word;
Begin
 GetOutNums:=OutList^.Count
End;

Function TCompilator.GetOutDesc(Num:integer; Var IdDef:TIdDef):boolean;
Var P:POutVar;
Begin
 If Num>OutList^.Count then GetOutDesc:=False
 else begin
  P:=OutList^.At(Num-1);
  With P^ do begin
   IdDef.Name:=@HVar^.Name;
   IdDef.Value:=@HVar^.Value;
   IdDef.F1:=F1; IdDef.F2:=F2
  end;
  GetOutDesc:=True
 end
End;

Destructor TCompilator.Done;
Begin
 Dispose(OutList, Done);
 Dispose(DefsColl, Done);
 If ProgrammCalcer<>nil then Dispose(ProgrammCalcer, Done);
 Inherited Done;
End;

Function TCompilator.CheckExtern(T:PToken; WhatBlock:byte):boolean;
Begin
 CheckExtern:=False
End;

Procedure TCompilator.Translate;
Var I:word;  K:PHashCell; T:PToken;
Begin
 SetJump(JumpPoint);
 If TransError=0 then begin
  DataBlocks:=TranslateBlock(wbGlobal);
  Compile;
 end;
 DisposeMemTmp(0);
End;

Procedure TCompilator.Compile;
Begin
 CompError.Error:=0;
 InWhile:=0;
 Mask8087(False);
 ProgrammCalcer:=New(PBlockCalcer, Init(DataBlocks,True));
 Mask8087(True);
 If CompError.Error<>0 then begin
  TransError:=CompError.Error;
  ErrorX:=CompError.cX; ErrorY:=CompError.cY
 end;
End;

Procedure TCompilator.Evaluate;
Begin
 Mask8087(False);
 ProgrammCalcer^.Evaluate;
 Mask8087(True)
End;

Function TCompilator.Calculate:PFloat;
Begin
 If LastFunc=nil then Calculate:=nil
 else begin
  Evaluate;
  Calculate:=@LastFunc^.Value
 end
End;

(*Procedure TCompilator.OutData;
Const
 Func2Symb:array[f1Error+1..f1Error+5] of char='+-*/^';
 LogicSymb:array[0..3] of string[3]=('and','or','not','xor');
 BoolSymb:array[0..5] of string[2]=('>','>=','<','<=','=','<>');

 Function Func1Symb(I:byte):string;
 Begin
  If I=f1Neg then Func1Symb:='-'
  else Func1Symb:=ResWords[I].Name
 end;

 Procedure OutFormula(T:PTermTree);
 Var S:string; P:PFunction; I:word;
 Begin
  If T<>nil then
   Case T^.TermType of
    opFunc2:begin
     write('(');
     OutFormula(T^.Head);
     write(Func2Symb[T^.What]);
     OutFormula(T^.Tail);
     write(')')
    end;
    opConst:begin
     Str(PFloat(T^.WhatR)^:6:2,S);
     While S[1]=' ' do System.Delete(S,1,1); {FastTrim(S);}
     write(S);
    end;
    opStringConst: write('''',PText(T^.WhatR)^,'''');
    opFunc1:begin
     write(Func1Symb(T^.What));
     write('(');
     OutFormula(T^.Head);
     write(')')
    end;
    opArrayVar,opStrArrVar:begin
     write(PHashCell(T^.WhatR)^.Name, '[');
     OutFormula(T^.Head);
     If T^.Tail<>nil then begin
      write(','); OutFormula(T^.Tail)
     end;
     write(']')
    end;
    opStrConcat:begin
     write('(');
     OutFormula(T^.Head);
     write('+');
     OutFormula(T^.Tail);
     write(')')
    end;
    opPolinom:begin
     write(PHashCell(T^.WhatR)^.Name, '(');
     OutFormula(T^.Head);
     write(')')
    end;
    opParProc..opUserProc:begin
     write(PHashCell(T^.WhatR)^.Name, '(');
     P:=PFunction(PHashCell(T^.WhatR)^.WhatD);
     For I:=1 to P^.NPars do begin
      Case P^.Pars[I].TermType of
       opPar,opStringPar,opArrayVar..opMatrixVar,opUserFunc,opUserProc:
        write(PHashCell(PFuncFacts(T^.Head)^[I].FTree)^.Name);
       opVar,opStringVar: OutFormula(PFuncFacts(T^.Head)^[I].FTree);
      end;
      If I<>P^.NPars then write(',') else write(')')
     end;
     If P^.NPars=0 then write(')')
    end;
    else { opPar..opDiff2,opStringVar,opStringPar }
     write(PHashCell(T^.WhatR)^.Name)
   end
  else write('?')
 end;

 Procedure OutLogic(T:PLogicTree);
 Begin
  If T<>nil then
   Case T^.What of
    etLogic:
     If T^.LogicOp=ltNOT then begin
      write(LogicSymb[T^.LogicOp]);
      write('(');
      OutLogic(T^.Left);
      write(')')
     end
     else begin
      write('(');
      OutLogic(T^.Left);
      write(') ');
      write(LogicSymb[T^.LogicOp]);

      write(' (');
      OutLogic(T^.Right);
      write(')')
     end;
     etBool:begin
      OutFormula(PBoolExpression(T^.Left)^.Left.FTree);
      If PBoolExpression(T^.Left)^.What>LastrtFloat then
       write(BoolSymb[PBoolExpression(T^.Left)^.What-LastrtFloat])
      else write(BoolSymb[PBoolExpression(T^.Left)^.What]);
      OutFormula(PBoolExpression(T^.Left)^.Right.FTree);
     end
    end
  else write('?')
 end;

 Procedure OutBlock(P:PBlockList);
 Const DefName:array[opArrayVar..opMatrixVar] of string[7]=
  ('ARRAY','POLINOM','MATRIX','');
 Var J,N,I,K:word; C:PCellList;
 Begin
  N:=P^.NBlocks+P^.NDefBlocks;
  For I:=1 to N do begin
   P:=P^.Next;
   Case P^.What of
    etFormula:begin
     write(PFormula(P^.Expr)^.Loc^.Name);
     write('=');
     OutFormula(PFormula(P^.Expr)^.E.FTree);
     writeln(';')
    end;

    etStrFormula:begin
     write(PFormula(P^.Expr)^.Loc^.Name);
     write('=');
     OutFormula(PFormula(P^.Expr)^.E.FTree);
     writeln(';')
    end;

    etProc:begin
     OutFormula(PExpression(P^.Expr)^.FTree);
     writeln(';')
    end;

    etWhile:begin
     write('While ');
     OutLogic(PWhileCycle(P^.Expr)^.Logic);
     writeln(' do');
     OutBlock(PWhileCycle(P^.Expr)^.BList);
     writeln('endwhile;')
    end;

    etIf:begin
     write('If ');
     OutLogic(PIfCycle(P^.Expr)^.Logic);
     writeln(' then');
     OutBlock(PIfCycle(P^.Expr)^.BListIf);
     write('endif');
     If PIfCycle(P^.Expr)^.BListElse=nil then writeln(';')
     else begin
      writeln;
      writeln('else');
      OutBlock(PIfCycle(P^.Expr)^.BListElse);
      writeln('endelse;');
     end
    end;

    etArrayCell,etStrArrayCell:begin
     With PArrayCell(P^.Expr)^ do begin
      write(Loc^.Name, '[');
      OutFormula(Index.FTree);
      If Index2.FTree<>nil then begin
       write(','); OutFormula(Index2.FTree)
      end;
      write(']=');
      OutFormula(FTree.FTree);
      writeln(';')
     end
    end;

    etArrayDef,etPolinomDef:begin
     With PStructDef(P^.Expr)^ do begin
      If P^.What=etArrayDef then write( 'Array[' )
      else write( 'Polinom[' );

      OutFormula( SizeVal.FTree );
      If Size2Val.FTree<>nil then begin
       write(','); OutFormula( Size2Val.FTree )
      end;
      write( ']' );

      If MType=StringM then
        write(' of string['+Long2Str(longint(Data))+'] ');

      write( NameHash^.Name );
      If (Cells>0) or Extern then write( '=' );
      If Extern then write( 'EXTERN' );
      C:=CellList;
      For J:=1 to Cells do begin
       C:=C^.Next;
       If MType=StringM then write('"',Pstring(C^.F.FTree)^,'"')
       else OutFormula( C^.F.FTree);
       If J<>Cells then write( ',' );
      end;
      writeln( ';' );
     end
    end;

    etFuncDef,etProcDef:begin
     With PFunction(P^.Expr)^ do begin
      write('Func ',FuncName^.Name, '(' );
      For J:=1 to NPars do With Pars[J] do begin
       Case TermType of
        opPar:write('@',Hash^.Name);
        opVar:write(Hash^.Name);
        opArrayVar..opMatrixVar:
         write(DefName[Pars[J].TermType], ' ',Hash^.Name);
        opUserFunc,opUserProc:begin
         write('func ',Hash^.Name, '(');
         With PFunction(Hash^.WhatD)^ do begin
          For K:=1 to NPars do With Pars[K] do begin
           Case TermType of
            opPar:write('@');
            opVar:write('*');
            opArrayVar..opMatrixVar: write(DefName[Pars[K].TermType]);
           end;
           If K<>NPars then write(',') else write(')')
          end
         end
        end;
        opStringVar:write('string ',Hash^.Name);
        opStringPar:write('@string ',Hash^.Name);
       end;
       If J<>NPars then write(',')
      end;
      If FuncName^.TermType=opStringFunc then writeln('):string;')
      else writeln(');');
      OutBlock(PBlockList(FuncCalc));
      writeln('endfunc;');
     end;
    end;

    etBreak: writeln('break; ');
    etContinue: writeln('continue; ');
    etExit: writeln('exit; ');

   end;
  end
 end;

Begin
 OutBlock(DataBlocks)
End; *)

End.

