Unit x1;
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Def2x2;

Const MaxHashKey=31;

Var 
 CurHashKey:byte;

Type
 PToken=^TToken;
 TToken=record
  X,Y:word;
  TermType:OpsType;
  TermWhat:byte;
  Ref:pointer;
  TermLen:byte
 end;

 PConstList=^TConstList;
 TConstList=record
  Value:extended;
  Next:PConstList
 end;

Type

 ByteArray=array[0..$FFF0] of byte;
 PByteA=^ByteArray;

 PointerRec=record
  P:PByteA;
  Size:word
 end;

Const
 MaxPointers=$FFF0 div SizeOf(PointerRec);
 PointerInc=250;

Type

 APointersList=array[1..MaxPointers] of PointerRec;
 PointersList=^APointersList;

Function IsSpecial(Chr:char; Var J:byte):boolean;
Function GetHashKey(Str:string):byte;
Procedure CalcHashKey(S:string);
Function IsLetter(Chr:char):boolean;
Function IsNumber(Chr:char):boolean;

Implementation

Function IsSpecial(Chr:char; Var J:byte):boolean;assembler;
{   ᨬ Chr   ᯥ. ᨬ, ।塞
  ப SpecialString. ᫨ ,  頥  ᨬ }
asm
 xor ah,ah
 les di,PSpecialString
 mov al,es:[di]
 mov bl,al
 inc di
 mov ch,ah
 mov cl,al
 mov al,Chr
 repne scasb
 jne @1
 sub bl,cl
 les di,J
 mov es:[di],bl
 inc ah
@1:
 mov al,ah
End;

Function GetHashKey(Str:string):byte;assembler;
{ ন  ப Str ᨬ, ⫨  㪢 . 䠢,
   0..9  ᨬ ન. ᫨ ᮤন, 
  頥  ᨬ.   ॣ
  ॢ  孨. 뢠 - CurHashKey }
Var Len:word;
asm
 push ds
 lds si,str
 cld
 lodsb
 mov cl,al
 xor ch,ch
 mov Len,cx
 xor dx,dx

@0:
 lodsb
 mov bx,7a61h { z,a }
 cmp al,bl
 jb @1 { <a }
 cmp al,bh
 ja @Error { >z }
 sub al,32
 mov ds:[si-1],al
 jmp @Next { a..z }

@1:
 mov bx,5b41h { Z+1,A }
 cmp al,bl
 jb @2 { <A }
 cmp al,bh
 jb @Next { A..Z }
 cmp al,5fh
 je @Next   { _ }

@Error:
 {  -, begin }
 shl dx,1
 xor dl,al
 { end }

 mov ax,Len
 sub al,cl
 inc al
 jmp @exit

@2:
 mov bx,3930h { 9,0 }
 cmp al,bl
 jb @Error { <0 }
 cmp al,bh
 ja @Error { >9 }

@Next:
 {  -, begin }
 shl dx,1
 xor dl,al
 { end }
 loop @0

 xor al,al
@exit:
 pop ds

 {  -, begin }
 or dx,dx
 jns @3
 neg dx
@3:
 mov bl,al
 mov ax,dx
 xor dx,dx
 mov cx,MaxHashKey
 div cx
 mov CurHashKey,dl
 mov al,bl
 { end }
End;

Procedure CalcHashKey(S:string);assembler;
asm
 push ds
 lds si,S
 cld
 lodsb
 mov cl,al
 xor ch,ch
 xor dx,dx
@1:
 lodsb
 shl dx,1
 xor dl,al
 loop @1

 pop ds
 xor ax,ax
 xchg ax,dx
 mov cx,MaxHashKey
 div cx
 mov CurHashKey,dl
End;

Function IsLetter(Chr:char):boolean;assembler;
asm
 xor al,al
 mov cl,chr
 cmp cl,'A'
 jb @1        { <A }
 cmp cl,'Z'
 jbe @2       { <=Z }
 cmp cl,'a'
 jb @1        { <a }
 cmp cl,'z'
 ja @1        { >z }
@2:
 inc al
@1:
end;

Function IsNumber(Chr:char):boolean;assembler;
asm
 xor al,al
 mov cl,chr
 cmp cl,'0'
 jb @1
 cmp cl,'9'
 ja @1
 inc al
@1:
end;

End.